/**************************************************************************/
/*          InDesignで表計算（CS2 以降）［計算式設定プログラム］          */
/*                                                            by お～まち */
/*                                               2009.04.30  Version 1.21 */
/**************************************************************************/
app.scriptPreferences.userInteractionLevel=UserInteractionLevels.interactWithAll;
if (app.selection.length == 1){
	if (app.selection[0].constructor.name == "Table"){
		tbl = app.selection[0];
		if (tbl.columns.length > 26){
			alert("表の最大列数は25です");
		} else {
			do_script(tbl);
		}
	} else {
		alert("表を1つ選択してください");
	}
} else {
	alert("表を1つ選択してください")
}
function do_script(tbl){
	const addchr = ["\xa5","\$","%","@","円","￥","＄","％","＠","\xa2","\xa3"];
	const minuschr = ["\uff0d","△","▲"];
	var cl = tbl.columns.length;
	var rl = tbl.rows.length;
	var pattern = new Array();
	var cell_adrs = new Array();
	var cell_type = new Array();
	var cell_fomt = new Array();
	var cell_calc = new Array();
	//ダイアログ１の作成
	dlg1 = app.dialogs.add();
	dlg1.name = "表計算設定1/4－数値書式パターンの登録";
	with(dlg1.dialogColumns.add()){
		with(dialogRows.add()){staticTexts.add({
			staticLabel:"最初に数値の書式を登録します。３種類登録できます"
		})};
		with(dialogRows.add()){staticTexts.add({staticLabel:""})};
		dlr = dialogRows.add();
	}
	with(dlr.dialogColumns.add()){
		with(dialogRows.add()){staticTexts.add({staticLabel:""});}
		with(dialogRows.add()){staticTexts.add({staticLabel:"3桁区切り"});}
		with(dialogRows.add()){staticTexts.add({staticLabel:""});}
		with(dialogRows.add()){staticTexts.add({staticLabel:"小数点以下の桁数"});}
		with(dialogRows.add()){staticTexts.add({staticLabel:"負記号"});}
		with(dialogRows.add()){staticTexts.add({staticLabel:""});}
		with(dialogRows.add()){staticTexts.add({staticLabel:""});}
		with(dialogRows.add()){staticTexts.add({staticLabel:"付加記号の有無"});}
		with(dialogRows.add()){staticTexts.add({staticLabel:""});}
		with(dialogRows.add()){staticTexts.add({staticLabel:"付加記号の種類"});}
	}
	for (var i=0 ; i<3 ; i++){
		with(dlr.dialogColumns.add()){
			with(dialogRows.add()){//0
				staticTexts.add({staticLabel:"【数値書式パターン"+(i+1)+"】"});
			}
			with(dialogRows.add()){//1
				with(radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"使用しない", checkedState:true});
					radiobuttonControls.add({staticLabel:"使用する"});
				}
			}
			with(dialogRows.add()){textEditboxes.add({editContents:"0"});}//2
			with(dialogRows.add()){//3
				with(radiobuttonGroups.add()){
					for (j=0 ; j<minuschr.length ; j++){
						radiobuttonControls.add({staticLabel:minuschr[j]});
					}
					radiobuttonControls[0].checkedState = true;
				}
			}
			with(dialogRows.add()){//4
				with(radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"なし", checkedState:true});
					radiobuttonControls.add({staticLabel:"前"});
					radiobuttonControls.add({staticLabel:"後"});
				}
			}
			with(dialogRows.add()){dropdowns.add({stringList: addchr, selectedIndex: 0});}//5
		}
	}
	if (dlg1.show()==false){return;}
	//ダイアログ設定値の保管
	pattern[0] = "------";
	for (i=1 ; i<4 ; i++){
		pattern[i] = "0000";
		if (dlr.dialogColumns[i].dialogRows[1].radiobuttonGroups[0].selectedButton == 1){
			pattern[i] = "0,000";
		}
		tempstr = dlr.dialogColumns[i].dialogRows[2].textEditboxes[0].editContents;
		if (tempstr != "0" && isNaN(tempstr) == false){
			pattern[i] = pattern[i] + ".";
			for (j=0 ; j<parseInt(tempstr) ; j++){pattern[i] = pattern[i] + "0";}
		}
		tempnum = dlr.dialogColumns[i].dialogRows[3].radiobuttonGroups[0].selectedButton;
		pattern[i] = minuschr[tempnum] + pattern[i];
		tempnum = dlr.dialogColumns[i].dialogRows[5].dropdowns[0].selectedIndex;
		switch(dlr.dialogColumns[i].dialogRows[4].radiobuttonGroups[0].selectedButton){
			case 1: pattern[i] = addchr[tempnum] + pattern[i]; break;
			case 2: pattern[i] = pattern[i] + addchr[tempnum]; break;
		}
	}
	dlg1.destroy();
	//ダイアログ２の作成
	dlg2 = app.dialogs.add();
	dlg2.name = "表計算設定2/4－セル属性の設定";
	dlc = dlg2.dialogColumns.add()
	with(dlc.dialogRows.add()){staticTexts.add({
		staticLabel:"セルの属性を[文字列], [数値], [計算式]から選んでください"
	})};
	myList = ["文字列","数値","計算式"];
	i = 0;
	for (var r=0 ; r<=rl ; r++){
		with(dlc.dialogRows.add()){
			for (var c=0 ; c<=cl ; c++){
				with(dialogColumns.add()){
					if (c==0){
						if (r!=0){staticTexts.add({staticLabel:r+""});}
					} else {
						if (r==0){
							staticTexts.add({
								staticLabel:String.fromCharCode(c+64), minWidth:90
							});
						} else {
							dropdowns.add({
								stringList: myList, selectedIndex:1, minWidth:90
							});
							cell_adrs[i] = String.fromCharCode(c+64) + r;
							i = i+1;
						}
					}
				}
			}
		}
	}
	if (dlg2.show()==false){return;}
	//ダイアログ設定値の保管
	i = 0;
	for (r=1 ; r<=rl ; r++){
		for (c=1 ; c<=cl ; c++){
			cell_type[i] = myList[dlc.dialogRows[r+1].dialogColumns[c].dropdowns[0].selectedIndex];
			i = i+1;
		}
	}
	dlg2.destroy();
	//ダイアログ３の作成
	dlg3 = app.dialogs.add();
	dlg3.name = "表計算設定3/4－数値書式パターンの割り当て";
	dlc = dlg3.dialogColumns.add()
	with(dlc.dialogRows.add()){
		staticTexts.add({
		staticLabel:"数値および計算式のセルに書式を割り当ててください"
		});
	}
	dlc.dialogRows.add()
	with(dlc.dialogRows.add()){
		staticTexts.add({
			staticLabel:"【入力されているものを変更しない】　（  ------  ）"
		});
	}
	for (i=1 ; i<4 ; i++){
		with(dlc.dialogRows.add()){
			staticTexts.add({
				staticLabel:"【数値書式パターン" + i + "】　（  " + pattern[i] + "  ）"
			});
		}
	}
	with(dlc.dialogRows.add()){dld = dialogColumns.add()}
	i = 0;
	for (r=0 ; r<=rl ; r++){
		with(dld.dialogRows.add()){
			for (c=0 ; c<=cl ; c++){
				with(dialogColumns.add()){
					if (c==0){
						if (r!=0){staticTexts.add({staticLabel:r+""});}
					} else {
						if (r==0){
							staticTexts.add({
								staticLabel:String.fromCharCode(c+64), minWidth:90
							});
						} else {
							switch(cell_type[i]){
								case "文字列":
									dropdowns.add({
										stringList: ["文字列"], selectedIndex:0, minWidth:90
									});break;
								case "数値":
									dropdowns.add({
										stringList: pattern, selectedIndex:0, minWidth:90
									});break;
								case "計算式":
									dropdowns.add({
										stringList: pattern, selectedIndex:1, minWidth:90
									});
							}
							i = i+1;
						}
					}
				}
			}
		}
	}
	if (dlg3.show()==false){return;}
	//ダイアログ設定値の保管
	i = 0;
	for (r=1 ; r<=rl ; r++){
		for (c=1 ; c<=cl ; c++){
			cell_fomt[i] = pattern[dld.dialogRows[r].dialogColumns[c].dropdowns[0].selectedIndex];
			i = i+1;
		}
	}
	dlg3.destroy();
	//ダイアログ４の作成
	dlg4 = app.dialogs.add();
	dlg4.name = "表計算設定4/4－計算式の設定";
	dlc = dlg4.dialogColumns.add()
	with(dlc.dialogRows.add()){
		staticTexts.add({
		staticLabel:"計算式のセルに計算式を入れてください（全角文字不可）"
		});
	}
	dlc.dialogRows.add()
	with(dlc.dialogRows.add()){
		staticTexts.add({
		staticLabel:"等号(=)は不要です。使用できる演算子は「 + - * / % ( ) 」"
		});
	}
	with(dlc.dialogRows.add()){
		staticTexts.add({
		staticLabel:"JavaScriptのMath関数も使用できるようです"
		});
	}
	with(dlc.dialogRows.add()){dld = dialogColumns.add()}
	i = 0;
	for (r=0 ; r<=rl ; r++){
		with(dld.dialogRows.add()){
			for (c=0 ; c<=cl ; c++){
				with(dialogColumns.add()){
					if (c == 0){
						if (r != 0){staticTexts.add({staticLabel:r+""});}
					} else {
						if (r == 0){
							staticTexts.add({
								staticLabel:String.fromCharCode(c+64), minWidth:90
							});
						} else {
							switch(cell_type[i]){
								case "文字列":
									textEditboxes.add({
										editContents: "文字列", minWidth:90
									});
									break;
								case "計算式":
									textEditboxes.add({
										editContents: "計算式を入れる", minWidth:90
									});
									break;
								case "数値":
									textEditboxes.add({
										editContents: cell_adrs[i], minWidth:90
									});
							}
							i = i+1;
						}
					}
				}
			}
		}
	}
	if (dlg4.show() == false){return;}
	//ダイアログ設定値の保管
	i = 0;
	for (r=1 ; r<=rl ; r++){
		for (c=1 ; c<=cl ; c++){
			var tempstr = dld.dialogRows[r].dialogColumns[c].textEditboxes[0].editContents;
			if (cell_type[i] == "計算式"){
				cell_calc[i] = replacestr(tempstr);
			} else {
				cell_calc[i] = "";
			}
			i = i+1;
		}
	}
	dlg4.destroy();
	//保管した設定をスクリプトラベルに転記
	i=0;
	for (r=0 ; r<rl ; r++){
		for (c=0 ; c<cl ; c++){
			tbl.rows[r].cells[c].label
				= cell_adrs[i] +"#"+ cell_type[i] +"#"+ cell_fomt[i] +"#"+ cell_calc[i];
			i = i+1;
		}
	}
	alert("計算式の設定が完了しました");
}
function replacestr(str1){
	var str2 = "";
	var han = " +-*/%().,abcdefghijklmnopqrstuvwxyz"
			+ "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	var zen = "　＋\uff0d＊／％（）．，ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ"
			+ "０１２３４５６７８９ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ";
	str1 = str1.replace(/^\s/,"").replace(/\s$/,"")
	for (s=0 ; s<str1.length ; s++){
		var chr1 = str1.charAt(s);
		if (han.indexOf(chr1) != -1){
			str2 = str2 + chr1;
		} else if (zen.indexOf(chr1) != -1){
			str2 = str2 + han.charAt(zen.indexOf(chr1));
		} else {
			alert("計算式に使用できない文字を削除しました\n" + chr1);
		}
	}
	str2 = str2.replace(/\+/g," + ").replace(/\-/g," - ").replace(/\*/g," * ").replace(/\//g," / ");
	str2 = str2.replace(/\%/g," % ").replace(/\(/g," ( ").replace(/\)/g," ) ").replace(/\,/g," , ");
	str2 = str2.replace(/\s\s*/g," ");
	return str2;
}